//
//  essai_MysqlAppDelegate.m
//
//  Created by philippe on 19/08/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "essai_MysqlAppDelegate.h"

@implementation essai_MysqlAppDelegate
- (IBAction)bt_auteur_click:(id)sender {
    NSString *sql = [NSString stringWithFormat:@"SELECT * FROM auteur"];
	NSString *tbNom = @"auteur";
    [self ConsulterTable:sql nomTable:tbNom sortieTable:text_auteur];
}

- (IBAction)bt_livre_click:(id)sender {
	NSString *auteur=[list_auteur titleOfSelectedItem]; 
	NSString *sql = [NSString stringWithFormat:@"SELECT l.* FROM livre l, auteur a WHERE l.NUMERO_A=a.NUMERO_A and a.NOM='%s'",[auteur cStringUsingEncoding:NSUTF8StringEncoding]];
	NSString *tbNom = @"livre";
    [self ConsulterTable:sql nomTable:tbNom sortieTable:text_livre];
}


//initialisation
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification 
{
	const char *dbhost="127.0.0.1", *dbname="gestion_livres", *dbpass="", *dbuser="root";
	
	mysql_init(&mysql); 
	mysql_options(&mysql, MYSQL_OPT_CONNECT_TIMEOUT, "2"); 
	
	if (!(mysql_real_connect(&mysql, dbhost, dbuser, dbpass, dbname, 0, NULL, 0))) 
	{ 
		[text_etat setStringValue:[NSString stringWithFormat:@"Erreur de connection : %s",mysql_error(&mysql)]];	
	} 
	else 
	{ 
	    [text_etat setStringValue:@"Connection OK.."];	
		
		//initialisation
		[self initListAuteur];
		
		[text_auteur setFont:[NSFont fontWithName:@"Menlo" size:11]];
		[text_livre setFont:[NSFont fontWithName:@"Menlo" size:11]];
	} 
}


//obtenir la liste des auteurs
- (void)initListAuteur
{
	NSMutableArray *auteurs = [[NSMutableArray alloc] init]; 
	NSString *sql = [NSString stringWithFormat:@"SELECT NOM FROM auteur"];
	
    if (mysql_real_query(&mysql,[sql cStringUsingEncoding:NSUTF8StringEncoding],[sql length]) == 0)
    {
		MYSQL_RES	*resultat = mysql_store_result(&mysql);
		MYSQL_ROW	ligne;
		while (ligne = mysql_fetch_row(resultat))
		{
			NSString	*nom = [NSString stringWithCString:ligne[0] encoding:NSUTF8StringEncoding];
			[auteurs addObject:nom];
		}
		mysql_free_result(resultat);
	}
	
	//remplire la liste.
	[list_auteur removeAllItems];
	[list_auteur addItemsWithTitles:auteurs];
	[list_auteur selectItemAtIndex:0];
	[list_auteur setNeedsDisplay:YES];
}


- (void)ConsulterTable:(NSString *)sql nomTable:(NSString*)tbNom sortieTable:(NSTextField*)sortie 
{
	NSString	*resultString = @"";
	unsigned int num_fields = 4;
	
	resultString = [resultString stringByAppendingString:[self creerSeparateur]];
	resultString = [resultString stringByAppendingString:[self obtenirTitresTable:tbNom]];
	resultString = [resultString stringByAppendingString:[self creerSeparateur]];
	
	if (mysql_real_query(&mysql,[sql cStringUsingEncoding:NSUTF8StringEncoding],[sql length]) == 0)
    {
		MYSQL_RES	*resultat = mysql_store_result(&mysql);
		MYSQL_ROW	ligne;
		while (ligne = mysql_fetch_row(resultat))
		{
			//NSLog(@"--> %s\n",ligne[0]);
			resultString = [resultString stringByAppendingString:@"|"];
			for(int i = 0; i < num_fields; i++)
				resultString = [resultString stringByAppendingFormat:@" %-*s|",12, ligne[i] ? ligne[i] : " "];
			
			resultString = [resultString stringByAppendingString:@"\n"];
		}
		
		resultString = [resultString stringByAppendingString:[self creerSeparateur]];
		mysql_free_result(resultat);
	}
	
	[sortie setStringValue:resultString];
}

- (NSString *)creerSeparateur
{
	NSString	*sep = @"";
	int	i , j;
	sep = [sep stringByAppendingString:@"+"];
	for (j = 0; j < 4; j++)
	{
		for (i = 0; i <= 12; i++)
			sep = [sep stringByAppendingString:@"-"];
		sep = [sep stringByAppendingString:@"+"];
	}
	
	sep = [sep stringByAppendingString:@"\n"];
	return sep;
} 

//obtenir la liste des auteurs
- (NSString *)obtenirTitresTable:(NSString *)tbNom
{	
	NSString	*titre = @"|";
	NSString	*sql = [NSString stringWithFormat:@"SHOW COLUMNS FROM %s",[tbNom cStringUsingEncoding:NSUTF8StringEncoding]];
	
    if (mysql_real_query(&mysql,[sql cStringUsingEncoding:NSUTF8StringEncoding],[sql length]) == 0)
    {
		MYSQL_RES		*resultat = mysql_store_result(&mysql);
		MYSQL_ROW		ligne;
		while (ligne = mysql_fetch_row(resultat))
			titre = [titre stringByAppendingFormat:@" %-*s|",12, ligne[0]? ligne[0] : " "];
		titre = [titre stringByAppendingFormat:@"\n"];
		mysql_free_result(resultat);
	}
	return titre;
}

@end
